/* VpnMenuItem.c generated by valac 0.34.9, the Vala compiler
 * generated from VpnMenuItem.vala, do not modify */

/*
 * Copyright (c) 2017 elementary LLC. (http://launchpad.net/elementary)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <nm-remote-connection.h>
#include <nm-connection.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define NETWORK_TYPE_VPN_MENU_ITEM (network_vpn_menu_item_get_type ())
#define NETWORK_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem))
#define NETWORK_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItemClass))
#define NETWORK_IS_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_IS_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_VPN_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItemClass))

typedef struct _NetworkVpnMenuItem NetworkVpnMenuItem;
typedef struct _NetworkVpnMenuItemClass NetworkVpnMenuItemClass;
typedef struct _NetworkVpnMenuItemPrivate NetworkVpnMenuItemPrivate;

#define NETWORK_TYPE_STATE (network_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NetworkVpnMenuItem {
	GtkListBoxRow parent_instance;
	NetworkVpnMenuItemPrivate * priv;
};

struct _NetworkVpnMenuItemClass {
	GtkListBoxRowClass parent_class;
};

typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_DISCONNECTED_WIRED,
	NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

struct _NetworkVpnMenuItemPrivate {
	NMRemoteConnection* _connection;
	NetworkState _vpn_state;
	GtkRadioButton* _radio_button;
	GtkSpinner* spinner;
	GtkImage* error_img;
};


static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkRadioButton* network_vpn_menu_item_blank_button;
static GtkRadioButton* network_vpn_menu_item_blank_button = NULL;

GType network_vpn_menu_item_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
#define NETWORK_VPN_MENU_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItemPrivate))
enum  {
	NETWORK_VPN_MENU_ITEM_DUMMY_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION,
	NETWORK_VPN_MENU_ITEM_ID,
	NETWORK_VPN_MENU_ITEM_VPN_STATE,
	NETWORK_VPN_MENU_ITEM_RADIO_BUTTON
};
NetworkVpnMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection);
NetworkVpnMenuItem* network_vpn_menu_item_construct (GType object_type, NMRemoteConnection* _connection);
static void network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self, NMRemoteConnection* value);
NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVpnMenuItem* self);
static void network_vpn_menu_item_update (NetworkVpnMenuItem* self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender, gpointer self);
static void network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self, GtkRadioButton* value);
GtkRadioButton* network_vpn_menu_item_get_radio_button (NetworkVpnMenuItem* self);
static gboolean __lambda16_ (NetworkVpnMenuItem* self, GtkWidget* b, GdkEventButton* ev);
static gboolean ___lambda16__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
NetworkVpnMenuItem* network_vpn_menu_item_new_blank (void);
NetworkVpnMenuItem* network_vpn_menu_item_construct_blank (GType object_type);
static void network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self, GtkWidget* w);
NetworkState network_vpn_menu_item_get_vpn_state (NetworkVpnMenuItem* self);
static void network_vpn_menu_item_show_item (NetworkVpnMenuItem* self, GtkWidget* w);
void network_vpn_menu_item_set_active (NetworkVpnMenuItem* self, gboolean active);
void network_vpn_menu_item_hide_icons (NetworkVpnMenuItem* self, gboolean show_remove_button);
const gchar* network_vpn_menu_item_get_id (NetworkVpnMenuItem* self);
void network_vpn_menu_item_set_vpn_state (NetworkVpnMenuItem* self, NetworkState value);
static void network_vpn_menu_item_finalize (GObject* obj);
static void _vala_network_vpn_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender, gpointer self) {
#line 36 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 127 "VpnMenuItem.c"
}


static gboolean __lambda16_ (NetworkVpnMenuItem* self, GtkWidget* b, GdkEventButton* ev) {
	gboolean result = FALSE;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_emit_by_name (self, "user-action");
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	result = FALSE;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 143 "VpnMenuItem.c"
}


static gboolean ___lambda16__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda16_ ((NetworkVpnMenuItem*) self, _sender, event);
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 152 "VpnMenuItem.c"
}


static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 64 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 159 "VpnMenuItem.c"
}


NetworkVpnMenuItem* network_vpn_menu_item_construct (GType object_type, NMRemoteConnection* _connection) {
	NetworkVpnMenuItem * self = NULL;
	NMRemoteConnection* _tmp0_ = NULL;
	NMRemoteConnection* _tmp1_ = NULL;
	GtkBox* main_box = NULL;
	GtkBox* _tmp2_ = NULL;
	GtkBox* _tmp3_ = NULL;
	GtkBox* _tmp4_ = NULL;
	GtkRadioButton* _tmp5_ = NULL;
	GtkRadioButton* _tmp6_ = NULL;
	GtkRadioButton* _tmp7_ = NULL;
	GtkRadioButton* _tmp10_ = NULL;
	GtkImage* _tmp11_ = NULL;
	GtkImage* _tmp12_ = NULL;
	GtkImage* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	GtkSpinner* _tmp15_ = NULL;
	GtkSpinner* _tmp16_ = NULL;
	GtkSpinner* _tmp17_ = NULL;
	GtkSpinner* _tmp18_ = NULL;
	GtkSpinner* _tmp19_ = NULL;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	GtkBox* _tmp22_ = NULL;
	GtkRadioButton* _tmp23_ = NULL;
	GtkBox* _tmp24_ = NULL;
	GtkSpinner* _tmp25_ = NULL;
	GtkBox* _tmp26_ = NULL;
	GtkImage* _tmp27_ = NULL;
	GtkRadioButton* _tmp28_ = NULL;
	GtkBox* _tmp29_ = NULL;
	GtkStyleContext* _tmp30_ = NULL;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 35 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = _connection;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_connection (self, _tmp0_);
#line 36 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = self->priv->_connection;
#line 36 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((NMConnection*) _tmp1_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp2_);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	main_box = _tmp2_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = main_box;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = main_box;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, 6);
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp3_, 6);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp5_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp6_ = _tmp5_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp6_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp6_);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp7_ = network_vpn_menu_item_blank_button;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	if (_tmp7_ != NULL) {
#line 233 "VpnMenuItem.c"
		GtkRadioButton* _tmp8_ = NULL;
		GtkRadioButton* _tmp9_ = NULL;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		_tmp8_ = self->priv->_radio_button;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		_tmp9_ = network_vpn_menu_item_blank_button;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		gtk_radio_button_join_group (_tmp8_, _tmp9_);
#line 242 "VpnMenuItem.c"
	}
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp10_ = self->priv->_radio_button;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp10_, "button-release-event", (GCallback) ___lambda16__gtk_widget_button_release_event, self, 0);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp11_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", GTK_ICON_SIZE_MENU);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp11_);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->error_img = _tmp11_;
#line 52 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp12_ = self->priv->error_img;
#line 52 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 6);
#line 53 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp13_ = self->priv->error_img;
#line 53 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp14_ = _ ("This Virtual Private Network could not be connected to.");
#line 53 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp14_);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp15_ = (GtkSpinner*) gtk_spinner_new ();
#line 55 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp15_);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->spinner = _tmp15_;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp16_ = self->priv->spinner;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_spinner_start (_tmp16_);
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp17_ = self->priv->spinner;
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp17_, FALSE);
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp18_ = self->priv->spinner;
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp19_ = self->priv->spinner;
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp20_ = gtk_widget_get_visible ((GtkWidget*) _tmp19_);
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp21_ = _tmp20_;
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp18_, !_tmp21_);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp22_ = main_box;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp23_ = self->priv->_radio_button;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, TRUE, TRUE, (guint) 0);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp24_ = main_box;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp25_ = self->priv->spinner;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, FALSE, FALSE, (guint) 0);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp26_ = main_box;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp27_ = self->priv->error_img;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp26_, (GtkWidget*) _tmp27_, FALSE, FALSE, (guint) 0);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::vpn_state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp28_ = self->priv->_radio_button;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) _tmp28_, "notify::active", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp29_ = main_box;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp30_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_class (_tmp30_, "menuitem");
#line 70 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update (self);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (main_box);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 330 "VpnMenuItem.c"
}


NetworkVpnMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection) {
#line 34 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection);
#line 337 "VpnMenuItem.c"
}


/**
    * Only used for an item which is not displayed: hacky way to have no radio button selected.
    **/
NetworkVpnMenuItem* network_vpn_menu_item_construct_blank (GType object_type) {
	NetworkVpnMenuItem * self = NULL;
	GtkRadioButton* _tmp0_ = NULL;
	GtkRadioButton* _tmp1_ = NULL;
	GtkRadioButton* _tmp2_ = NULL;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp1_);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp1_);
#line 78 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = self->priv->_radio_button;
#line 78 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_blank_button = _tmp2_;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 367 "VpnMenuItem.c"
}


NetworkVpnMenuItem* network_vpn_menu_item_new_blank (void) {
#line 76 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct_blank (NETWORK_TYPE_VPN_MENU_ITEM);
#line 374 "VpnMenuItem.c"
}


static void network_vpn_menu_item_update (NetworkVpnMenuItem* self) {
	GtkRadioButton* _tmp0_ = NULL;
	NMRemoteConnection* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GtkImage* _tmp3_ = NULL;
	GtkSpinner* _tmp4_ = NULL;
	NetworkState _tmp5_ = 0;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = self->priv->_connection;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = self->priv->error_img;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp3_);
#line 88 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = self->priv->spinner;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp4_);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = self->priv->_vpn_state;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	switch (_tmp5_) {
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_FAILED_VPN:
#line 409 "VpnMenuItem.c"
		{
			GtkImage* _tmp6_ = NULL;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			_tmp6_ = self->priv->error_img;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp6_);
#line 96 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			break;
#line 418 "VpnMenuItem.c"
		}
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_CONNECTING_VPN:
#line 422 "VpnMenuItem.c"
		{
			GtkSpinner* _tmp7_ = NULL;
			GtkRadioButton* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			_tmp7_ = self->priv->spinner;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp7_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			_tmp8_ = self->priv->_radio_button;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			_tmp10_ = _tmp9_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			if (!_tmp10_) {
#line 100 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
				g_critical ("VpnMenuItem.vala:100: An VPN is being connected but not active.");
#line 442 "VpnMenuItem.c"
			}
#line 102 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
			break;
#line 446 "VpnMenuItem.c"
		}
		default:
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 451 "VpnMenuItem.c"
	}
}


void network_vpn_menu_item_set_active (NetworkVpnMenuItem* self, gboolean active) {
	GtkRadioButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = active;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
#line 467 "VpnMenuItem.c"
}


void network_vpn_menu_item_hide_icons (NetworkVpnMenuItem* self, gboolean show_remove_button) {
#line 110 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 474 "VpnMenuItem.c"
}


static void network_vpn_menu_item_show_item (NetworkVpnMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 122 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = w;
#line 122 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (_tmp0_, TRUE);
#line 123 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = w;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = w;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
#line 123 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = _tmp3_;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (_tmp1_, _tmp4_);
#line 502 "VpnMenuItem.c"
}


static void network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GtkWidget* _tmp5_ = NULL;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = w;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (_tmp0_, FALSE);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = w;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = w;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = _tmp3_;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (_tmp1_, !_tmp4_);
#line 129 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = w;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_hide (_tmp5_);
#line 535 "VpnMenuItem.c"
}


NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVpnMenuItem* self) {
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 550 "VpnMenuItem.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 557 "VpnMenuItem.c"
}


static void network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self, NMRemoteConnection* value) {
	NMRemoteConnection* _tmp0_ = NULL;
	NMRemoteConnection* _tmp1_ = NULL;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = value;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_connection);
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->_connection = _tmp1_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_notify ((GObject *) self, "connection");
#line 576 "VpnMenuItem.c"
}


const gchar* network_vpn_menu_item_get_id (NetworkVpnMenuItem* self) {
	const gchar* result;
	NMRemoteConnection* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 24 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 25 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = nm_connection_get_id ((NMConnection*) _tmp0_);
#line 25 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp1_;
#line 25 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 594 "VpnMenuItem.c"
}


NetworkState network_vpn_menu_item_get_vpn_state (NetworkVpnMenuItem* self) {
	NetworkState result;
	NetworkState _tmp0_ = 0;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_vpn_state;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 609 "VpnMenuItem.c"
}


void network_vpn_menu_item_set_vpn_state (NetworkVpnMenuItem* self, NetworkState value) {
	NetworkState _tmp0_ = 0;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = value;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->_vpn_state = _tmp0_;
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_notify ((GObject *) self, "vpn-state");
#line 623 "VpnMenuItem.c"
}


GtkRadioButton* network_vpn_menu_item_get_radio_button (NetworkVpnMenuItem* self) {
	GtkRadioButton* result;
	GtkRadioButton* _tmp0_ = NULL;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 638 "VpnMenuItem.c"
}


static void network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self, GtkRadioButton* value) {
	GtkRadioButton* _tmp0_ = NULL;
	GtkRadioButton* _tmp1_ = NULL;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_radio_button);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->_radio_button = _tmp1_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_notify ((GObject *) self, "radio-button");
#line 657 "VpnMenuItem.c"
}


static void network_vpn_menu_item_class_init (NetworkVpnMenuItemClass * klass) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_type_class_add_private (klass, sizeof (NetworkVpnMenuItemPrivate));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION, g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_ID, g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_VPN_STATE, g_param_spec_enum ("vpn-state", "vpn-state", "vpn-state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_RADIO_BUTTON, g_param_spec_object ("radio-button", "radio-button", "radio-button", gtk_radio_button_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	g_signal_new ("user_action", NETWORK_TYPE_VPN_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 682 "VpnMenuItem.c"
}


static void network_vpn_menu_item_instance_init (NetworkVpnMenuItem * self) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv = NETWORK_VPN_MENU_ITEM_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self->priv->_vpn_state = NETWORK_STATE_DISCONNECTED;
#line 691 "VpnMenuItem.c"
}


static void network_vpn_menu_item_finalize (GObject* obj) {
	NetworkVpnMenuItem * self;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_connection);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_radio_button);
#line 31 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
#line 709 "VpnMenuItem.c"
}


GType network_vpn_menu_item_get_type (void) {
	static volatile gsize network_vpn_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkVpnMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&network_vpn_menu_item_type_id__volatile, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__volatile;
}


static void _vala_network_vpn_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_ID:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_string (value, network_vpn_menu_item_get_id (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_enum (value, network_vpn_menu_item_get_vpn_state (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_radio_button (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 754 "VpnMenuItem.c"
		default:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 760 "VpnMenuItem.c"
	}
}


static void _vala_network_vpn_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_vpn_state (self, g_value_get_enum (value));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_radio_button (self, g_value_get_object (value));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 788 "VpnMenuItem.c"
		default:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/VpnMenuItem.vala"
		break;
#line 794 "VpnMenuItem.c"
	}
}



