/* WifiMenuItem.c generated by valac 0.34.9, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <nm-access-point.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <nm-utils.h>
#include <stdlib.h>
#include <string.h>
#include <NetworkManager.h>


#define NETWORK_TYPE_WIFI_MENU_ITEM (network_wifi_menu_item_get_type ())
#define NETWORK_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem))
#define NETWORK_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))
#define NETWORK_IS_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_IS_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_WIFI_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))

typedef struct _NetworkWifiMenuItem NetworkWifiMenuItem;
typedef struct _NetworkWifiMenuItemClass NetworkWifiMenuItemClass;
typedef struct _NetworkWifiMenuItemPrivate NetworkWifiMenuItemPrivate;

#define NETWORK_TYPE_STATE (network_state_get_type ())
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetworkWifiMenuItem {
	GtkListBoxRow parent_instance;
	NetworkWifiMenuItemPrivate * priv;
};

struct _NetworkWifiMenuItemClass {
	GtkListBoxRowClass parent_class;
};

typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_DISCONNECTED_WIRED,
	NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

struct _NetworkWifiMenuItemPrivate {
	GList* _ap;
	NetworkState _state;
	NMAccessPoint* _tmp_ap;
	GtkRadioButton* radio_button;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
};


static gpointer network_wifi_menu_item_parent_class = NULL;

GType network_wifi_menu_item_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
#define NETWORK_WIFI_MENU_ITEM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemPrivate))
enum  {
	NETWORK_WIFI_MENU_ITEM_DUMMY_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID,
	NETWORK_WIFI_MENU_ITEM_STATE,
	NETWORK_WIFI_MENU_ITEM_STRENGTH,
	NETWORK_WIFI_MENU_ITEM_AP
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
NetworkWifiMenuItem* network_wifi_menu_item_new (NMAccessPoint* ap, NetworkWifiMenuItem* previous);
NetworkWifiMenuItem* network_wifi_menu_item_construct (GType object_type, NMAccessPoint* ap, NetworkWifiMenuItem* previous);
static GSList* network_wifi_menu_item_get_group (NetworkWifiMenuItem* self);
void network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self, NMAccessPoint* ap);
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static gboolean __lambda6_ (NetworkWifiMenuItem* self, GtkWidget* b, GdkEventButton* ev);
static gboolean ___lambda6__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
NetworkWifiMenuItem* network_wifi_menu_item_new_blank (void);
NetworkWifiMenuItem* network_wifi_menu_item_construct_blank (GType object_type);
static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_active (NetworkWifiMenuItem* self, gboolean active);
NMAccessPoint* network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self);
static gchar* network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self, guint8 strength);
guint8 network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self, GtkWidget* w);
NetworkState network_wifi_menu_item_get_state (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self, GtkWidget* w);
void network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self);
gboolean network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self, NMAccessPoint* ap);
GByteArray* network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_state (NetworkWifiMenuItem* self, NetworkState value);
static void network_wifi_menu_item_finalize (GObject* obj);
static void _vala_network_wifi_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _g_object_unref0_ (gpointer var) {
#line 19 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 135 "WifiMenuItem.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 19 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 19 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_list_free (self);
#line 144 "WifiMenuItem.c"
}


static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 84 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
#line 151 "WifiMenuItem.c"
}


static gboolean __lambda6_ (NetworkWifiMenuItem* self, GtkWidget* b, GdkEventButton* ev) {
	gboolean result = FALSE;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 88 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_signal_emit_by_name (self, "user-action");
#line 89 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = FALSE;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 167 "WifiMenuItem.c"
}


static gboolean ___lambda6__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda6_ ((NetworkWifiMenuItem*) self, _sender, event);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 176 "WifiMenuItem.c"
}


NetworkWifiMenuItem* network_wifi_menu_item_construct (GType object_type, NMAccessPoint* ap, NetworkWifiMenuItem* previous) {
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_ = NULL;
	GtkRadioButton* _tmp1_ = NULL;
	GtkRadioButton* _tmp2_ = NULL;
	NetworkWifiMenuItem* _tmp3_ = NULL;
	GtkImage* _tmp7_ = NULL;
	GtkImage* _tmp8_ = NULL;
	GtkImage* _tmp9_ = NULL;
	GtkImage* _tmp10_ = NULL;
	GtkImage* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	GtkSpinner* _tmp13_ = NULL;
	GtkSpinner* _tmp14_ = NULL;
	GtkSpinner* _tmp15_ = NULL;
	GtkSpinner* _tmp16_ = NULL;
	GtkSpinner* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp20_ = NULL;
	GtkRadioButton* _tmp21_ = NULL;
	GtkSpinner* _tmp22_ = NULL;
	GtkImage* _tmp23_ = NULL;
	GtkImage* _tmp24_ = NULL;
	GtkImage* _tmp25_ = NULL;
	NMAccessPoint* _tmp26_ = NULL;
	GtkRadioButton* _tmp27_ = NULL;
	GtkRadioButton* _tmp28_ = NULL;
	GtkStyleContext* _tmp29_ = NULL;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 49 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 49 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 49 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 49 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp0_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->radio_button;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = self->priv->radio_button;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 6);
#line 53 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = previous;
#line 53 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	if (_tmp3_ != NULL) {
#line 234 "WifiMenuItem.c"
		GtkRadioButton* _tmp4_ = NULL;
		NetworkWifiMenuItem* _tmp5_ = NULL;
		GSList* _tmp6_ = NULL;
#line 54 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp4_ = self->priv->radio_button;
#line 54 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp5_ = previous;
#line 54 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp6_ = network_wifi_menu_item_get_group (_tmp5_);
#line 54 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		gtk_radio_button_set_group (_tmp4_, _tmp6_);
#line 246 "WifiMenuItem.c"
	}
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp7_ = (GtkImage*) gtk_image_new ();
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp7_);
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 57 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->img_strength = _tmp7_;
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp8_ = self->priv->img_strength;
#line 58 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 6);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", GTK_ICON_SIZE_MENU);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp9_);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->lock_img = _tmp9_;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", GTK_ICON_SIZE_MENU);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp10_);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 63 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->error_img = _tmp10_;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp11_ = self->priv->error_img;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp12_ = _ ("This wireless network could not be connected to.");
#line 64 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp12_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp13_ = (GtkSpinner*) gtk_spinner_new ();
#line 66 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp13_);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->spinner = _tmp13_;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->spinner;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_spinner_start (_tmp14_);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp15_ = self->priv->spinner;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp16_ = self->priv->spinner;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp17_ = self->priv->spinner;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp18_ = gtk_widget_get_visible ((GtkWidget*) _tmp17_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp19_ = _tmp18_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp16_, !_tmp19_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp20_ = (GtkGrid*) gtk_grid_new ();
#line 71 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp20_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	grid = _tmp20_;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_grid_set_column_spacing (grid, 6);
#line 73 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp21_ = self->priv->radio_button;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp21_);
#line 74 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->spinner;
#line 74 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp22_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp23_ = self->priv->error_img;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp23_);
#line 76 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp24_ = self->priv->lock_img;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp24_);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp25_ = self->priv->img_strength;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) _tmp25_);
#line 79 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	__g_list_free__g_object_unref0_0 (self->priv->_ap);
#line 79 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_ap = NULL;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp26_ = ap;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_add_ap (self, _tmp26_);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp27_ = self->priv->radio_button;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) _tmp27_, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp28_ = self->priv->radio_button;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp28_, "button-release-event", (GCallback) ___lambda6__gtk_widget_button_release_event, self, 0);
#line 92 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) grid);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_style_context_add_class (_tmp29_, "menuitem");
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (grid);
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return self;
#line 364 "WifiMenuItem.c"
}


NetworkWifiMenuItem* network_wifi_menu_item_new (NMAccessPoint* ap, NetworkWifiMenuItem* previous) {
#line 48 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
#line 371 "WifiMenuItem.c"
}


/**
 * Only used for an item which is not displayed: hacky way to have no radio button selected.
 **/
NetworkWifiMenuItem* network_wifi_menu_item_construct_blank (GType object_type) {
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_ = NULL;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp0_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return self;
#line 393 "WifiMenuItem.c"
}


NetworkWifiMenuItem* network_wifi_menu_item_new_blank (void) {
#line 99 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct_blank (NETWORK_TYPE_WIFI_MENU_ITEM);
#line 400 "WifiMenuItem.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 407 "WifiMenuItem.c"
}


static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self) {
	guint8 strength = 0U;
	GList* _tmp0_ = NULL;
#line 103 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 104 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 420 "WifiMenuItem.c"
	{
		GList* ap_collection = NULL;
		GList* ap_it = NULL;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		ap_collection = _tmp0_;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		for (ap_it = ap_collection; ap_it != NULL; ap_it = ap_it->next) {
#line 428 "WifiMenuItem.c"
			NMAccessPoint* _tmp1_ = NULL;
			NMAccessPoint* ap = NULL;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp1_ = _g_object_ref0 ((NMAccessPoint*) ap_it->data);
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			ap = _tmp1_;
#line 435 "WifiMenuItem.c"
			{
				NMAccessPoint* _tmp2_ = NULL;
				guint8 _tmp3_ = 0U;
				NMAccessPoint* _tmp4_ = NULL;
				guint8 _tmp5_ = 0U;
				NMAccessPoint* _tmp8_ = NULL;
				guint8 _tmp9_ = 0U;
				NMAccessPoint* _tmp10_ = NULL;
				guint8 _tmp11_ = 0U;
				guint8 _tmp12_ = 0U;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp3_ = strength;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp4_ = ap;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp5_ = nm_access_point_get_strength (_tmp4_);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				if (_tmp3_ > _tmp5_) {
#line 454 "WifiMenuItem.c"
					NMAccessPoint* _tmp6_ = NULL;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp6_ = self->priv->_tmp_ap;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp2_ = _tmp6_;
#line 460 "WifiMenuItem.c"
				} else {
					NMAccessPoint* _tmp7_ = NULL;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp7_ = ap;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp2_ = _tmp7_;
#line 467 "WifiMenuItem.c"
				}
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp8_ = _g_object_ref0 (_tmp2_);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_g_object_unref0 (self->priv->_tmp_ap);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				self->priv->_tmp_ap = _tmp8_;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp9_ = strength;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp10_ = ap;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp11_ = nm_access_point_get_strength (_tmp10_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp12_ = MAX (_tmp9_, _tmp11_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				strength = _tmp12_;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_g_object_unref0 (ap);
#line 487 "WifiMenuItem.c"
			}
		}
	}
}


void network_wifi_menu_item_set_active (NetworkWifiMenuItem* self, gboolean active) {
	GtkRadioButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 111 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 112 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = active;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
#line 505 "WifiMenuItem.c"
}


static GSList* network_wifi_menu_item_get_group (NetworkWifiMenuItem* self) {
	GSList* result = NULL;
	GtkRadioButton* _tmp0_ = NULL;
	GSList* _tmp1_ = NULL;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = gtk_radio_button_get_group (_tmp0_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp1_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 523 "WifiMenuItem.c"
}


static void network_wifi_menu_item_update (NetworkWifiMenuItem* self) {
	GtkRadioButton* _tmp0_ = NULL;
	NMAccessPoint* _tmp1_ = NULL;
	NMAccessPoint* _tmp2_ = NULL;
	GByteArray* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GtkImage* _tmp6_ = NULL;
	guint8 _tmp7_ = 0U;
	guint8 _tmp8_ = 0U;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GtkImage* _tmp15_ = NULL;
	NM80211ApSecurityFlags flags = 0;
	NMAccessPoint* _tmp16_ = NULL;
	NMAccessPoint* _tmp17_ = NULL;
	NM80211ApSecurityFlags _tmp18_ = 0;
	gboolean is_secured = FALSE;
	NM80211ApSecurityFlags _tmp19_ = 0;
	GtkImage* _tmp32_ = NULL;
	gboolean _tmp33_ = FALSE;
	GtkImage* _tmp34_ = NULL;
	GtkImage* _tmp35_ = NULL;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	GtkImage* _tmp38_ = NULL;
	GtkSpinner* _tmp39_ = NULL;
	NetworkState _tmp40_ = 0;
#line 119 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = network_wifi_menu_item_get_ap (self);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = _tmp1_;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = nm_access_point_get_ssid (_tmp2_);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp4_ = nm_utils_ssid_to_utf8 (_tmp3_);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp5_ = _tmp4_;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp5_);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp5_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp6_ = self->priv->img_strength;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp7_ = network_wifi_menu_item_get_strength (self);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp8_ = _tmp7_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp9_ = network_wifi_menu_item_strength_to_string (self, _tmp8_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp10_ = _tmp9_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp11_ = g_strconcat ("network-wireless-signal-", _tmp10_, NULL);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp12_ = _tmp11_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp13_ = g_strconcat (_tmp12_, "-symbolic", NULL);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp14_ = _tmp13_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_image_set_from_icon_name (_tmp6_, _tmp14_, GTK_ICON_SIZE_MENU);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp14_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp12_);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp10_);
#line 126 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp15_ = self->priv->img_strength;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp16_ = network_wifi_menu_item_get_ap (self);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp17_ = _tmp16_;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp18_ = nm_access_point_get_wpa_flags (_tmp17_);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	flags = _tmp18_;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	is_secured = FALSE;
#line 131 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp19_ = flags;
#line 131 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	if ((_tmp19_ & NM_802_11_AP_SEC_GROUP_WEP40) != 0) {
#line 621 "WifiMenuItem.c"
		const gchar* _tmp20_ = NULL;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		is_secured = TRUE;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp20_ = _ ("This network uses 40/64-bit WEP encryption");
#line 133 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp20_);
#line 629 "WifiMenuItem.c"
	} else {
		NM80211ApSecurityFlags _tmp21_ = 0;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp21_ = flags;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		if ((_tmp21_ & NM_802_11_AP_SEC_GROUP_WEP104) != 0) {
#line 636 "WifiMenuItem.c"
			const gchar* _tmp22_ = NULL;
#line 135 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			is_secured = TRUE;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp22_ = _ ("This network uses 104/128-bit WEP encryption");
#line 136 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp22_);
#line 644 "WifiMenuItem.c"
		} else {
			NM80211ApSecurityFlags _tmp23_ = 0;
#line 137 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp23_ = flags;
#line 137 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			if ((_tmp23_ & NM_802_11_AP_SEC_KEY_MGMT_PSK) != 0) {
#line 651 "WifiMenuItem.c"
				const gchar* _tmp24_ = NULL;
#line 138 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				is_secured = TRUE;
#line 139 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp24_ = _ ("This network uses WPA encryption");
#line 139 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp24_);
#line 659 "WifiMenuItem.c"
			} else {
				gboolean _tmp25_ = FALSE;
				NM80211ApSecurityFlags _tmp26_ = 0;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp26_ = flags;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				if (_tmp26_ != NM_802_11_AP_SEC_NONE) {
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp25_ = TRUE;
#line 669 "WifiMenuItem.c"
				} else {
					NMAccessPoint* _tmp27_ = NULL;
					NMAccessPoint* _tmp28_ = NULL;
					NM80211ApSecurityFlags _tmp29_ = 0;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp27_ = network_wifi_menu_item_get_ap (self);
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp28_ = _tmp27_;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp29_ = nm_access_point_get_rsn_flags (_tmp28_);
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp25_ = _tmp29_ != NM_802_11_AP_SEC_NONE;
#line 682 "WifiMenuItem.c"
				}
#line 140 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				if (_tmp25_) {
#line 686 "WifiMenuItem.c"
					const gchar* _tmp30_ = NULL;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					is_secured = TRUE;
#line 142 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp30_ = _ ("This network uses encryption");
#line 142 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp30_);
#line 694 "WifiMenuItem.c"
				} else {
					const gchar* _tmp31_ = NULL;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					_tmp31_ = _ ("This network is unsecured");
#line 144 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp31_);
#line 701 "WifiMenuItem.c"
				}
			}
		}
	}
#line 147 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp32_ = self->priv->lock_img;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp33_ = is_secured;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp32_, !_tmp33_);
#line 148 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp34_ = self->priv->lock_img;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp35_ = self->priv->lock_img;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp36_ = gtk_widget_get_visible ((GtkWidget*) _tmp35_);
#line 148 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp37_ = _tmp36_;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp34_, !_tmp37_);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp38_ = self->priv->error_img;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp38_);
#line 151 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp39_ = self->priv->spinner;
#line 151 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp39_);
#line 155 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp40_ = self->priv->_state;
#line 155 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	switch (_tmp40_) {
#line 155 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_FAILED_WIFI:
#line 736 "WifiMenuItem.c"
		{
			GtkImage* _tmp41_ = NULL;
#line 157 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp41_ = self->priv->error_img;
#line 157 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp41_);
#line 158 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			break;
#line 745 "WifiMenuItem.c"
		}
#line 155 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_CONNECTING_WIFI:
#line 749 "WifiMenuItem.c"
		{
			GtkSpinner* _tmp42_ = NULL;
			GtkRadioButton* _tmp43_ = NULL;
			gboolean _tmp44_ = FALSE;
			gboolean _tmp45_ = FALSE;
#line 160 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp42_ = self->priv->spinner;
#line 160 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp42_);
#line 161 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp43_ = self->priv->radio_button;
#line 161 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp44_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp43_);
#line 161 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp45_ = _tmp44_;
#line 161 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			if (!_tmp45_) {
#line 162 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				g_critical ("WifiMenuItem.vala:162: An access point is being connected but not acti" \
"ve.");
#line 769 "WifiMenuItem.c"
			}
#line 164 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			break;
#line 773 "WifiMenuItem.c"
		}
		default:
#line 155 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 778 "WifiMenuItem.c"
	}
}


void network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self) {
#line 168 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 786 "WifiMenuItem.c"
}


static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
#line 177 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 177 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 178 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = w;
#line 178 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (_tmp0_, TRUE);
#line 179 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = w;
#line 179 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = w;
#line 179 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
#line 179 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp4_ = _tmp3_;
#line 179 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (_tmp1_, !_tmp4_);
#line 814 "WifiMenuItem.c"
}


static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self, GtkWidget* w) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GtkWidget* _tmp5_ = NULL;
#line 182 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 182 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 183 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = w;
#line 183 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (_tmp0_, FALSE);
#line 184 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = w;
#line 184 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = w;
#line 184 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp3_ = gtk_widget_get_visible (_tmp2_);
#line 184 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp4_ = _tmp3_;
#line 184 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (_tmp1_, !_tmp4_);
#line 185 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp5_ = w;
#line 185 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	gtk_widget_hide (_tmp5_);
#line 847 "WifiMenuItem.c"
}


void network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self, NMAccessPoint* ap) {
	NMAccessPoint* _tmp0_ = NULL;
	NMAccessPoint* _tmp1_ = NULL;
#line 188 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 188 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (ap != NULL);
#line 189 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = ap;
#line 189 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 189 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_ap = g_list_append (self->priv->_ap, _tmp1_);
#line 190 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 192 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 868 "WifiMenuItem.c"
}


static gchar* network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self, guint8 strength) {
	gchar* result = NULL;
	guint8 _tmp0_ = 0U;
#line 195 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = strength;
#line 196 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	if (((gint) _tmp0_) < 30) {
#line 881 "WifiMenuItem.c"
		gchar* _tmp1_ = NULL;
#line 197 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp1_ = g_strdup ("weak");
#line 197 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		result = _tmp1_;
#line 197 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		return result;
#line 889 "WifiMenuItem.c"
	} else {
		guint8 _tmp2_ = 0U;
#line 198 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		_tmp2_ = strength;
#line 198 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		if (((gint) _tmp2_) < 55) {
#line 896 "WifiMenuItem.c"
			gchar* _tmp3_ = NULL;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp3_ = g_strdup ("ok");
#line 199 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			result = _tmp3_;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			return result;
#line 904 "WifiMenuItem.c"
		} else {
			guint8 _tmp4_ = 0U;
#line 200 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp4_ = strength;
#line 200 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			if (((gint) _tmp4_) < 80) {
#line 911 "WifiMenuItem.c"
				gchar* _tmp5_ = NULL;
#line 201 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp5_ = g_strdup ("good");
#line 201 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				result = _tmp5_;
#line 201 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				return result;
#line 919 "WifiMenuItem.c"
			} else {
				gchar* _tmp6_ = NULL;
#line 203 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp6_ = g_strdup ("excellent");
#line 203 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				result = _tmp6_;
#line 203 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				return result;
#line 928 "WifiMenuItem.c"
			}
		}
	}
}


gboolean network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self, NMAccessPoint* ap) {
	gboolean result = FALSE;
	NMAccessPoint* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
#line 207 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, FALSE);
#line 208 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = ap;
#line 208 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_ap = g_list_remove (self->priv->_ap, _tmp0_);
#line 209 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 210 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->_ap;
#line 210 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp2_ = g_list_length (_tmp1_);
#line 210 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp2_ > ((guint) 0);
#line 210 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 958 "WifiMenuItem.c"
}


GByteArray* network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self) {
	GByteArray* result;
	NMAccessPoint* _tmp0_ = NULL;
	GByteArray* _tmp1_ = NULL;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp1_;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 976 "WifiMenuItem.c"
}


NetworkState network_wifi_menu_item_get_state (NetworkWifiMenuItem* self) {
	NetworkState result;
	NetworkState _tmp0_ = 0;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_state;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 991 "WifiMenuItem.c"
}


void network_wifi_menu_item_set_state (NetworkWifiMenuItem* self, NetworkState value) {
	NetworkState _tmp0_ = 0;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = value;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_state = _tmp0_;
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_notify ((GObject *) self, "state");
#line 1005 "WifiMenuItem.c"
}


guint8 network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self) {
	guint8 result;
	guint8 strength = 0U;
	GList* _tmp0_ = NULL;
	guint8 _tmp6_ = 0U;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 31 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 1020 "WifiMenuItem.c"
	{
		GList* ap_collection = NULL;
		GList* ap_it = NULL;
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		ap_collection = _tmp0_;
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		for (ap_it = ap_collection; ap_it != NULL; ap_it = ap_it->next) {
#line 1028 "WifiMenuItem.c"
			NMAccessPoint* _tmp1_ = NULL;
			NMAccessPoint* ap = NULL;
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			_tmp1_ = _g_object_ref0 ((NMAccessPoint*) ap_it->data);
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
			ap = _tmp1_;
#line 1035 "WifiMenuItem.c"
			{
				guint8 _tmp2_ = 0U;
				NMAccessPoint* _tmp3_ = NULL;
				guint8 _tmp4_ = 0U;
				guint8 _tmp5_ = 0U;
#line 33 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp2_ = strength;
#line 33 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp3_ = ap;
#line 33 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp4_ = nm_access_point_get_strength (_tmp3_);
#line 33 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_tmp5_ = MAX (_tmp2_, _tmp4_);
#line 33 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				strength = _tmp5_;
#line 32 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
				_g_object_unref0 (ap);
#line 1053 "WifiMenuItem.c"
			}
		}
	}
#line 35 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp6_ = strength;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp6_;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1063 "WifiMenuItem.c"
}


NMAccessPoint* network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self) {
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_ = NULL;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	return result;
#line 1078 "WifiMenuItem.c"
}


static void network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_type_class_add_private (klass, sizeof (NetworkWifiMenuItemPrivate));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID, g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTE_ARRAY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE, g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH, g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP, g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	g_signal_new ("user_action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1103 "WifiMenuItem.c"
}


static void network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv = NETWORK_WIFI_MENU_ITEM_GET_PRIVATE (self);
#line 27 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
#line 1112 "WifiMenuItem.c"
}


static void network_wifi_menu_item_finalize (GObject* obj) {
	NetworkWifiMenuItem * self;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 19 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	__g_list_free__g_object_unref0_0 (self->priv->_ap);
#line 40 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_tmp_ap);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 44 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 45 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 46 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
#line 1136 "WifiMenuItem.c"
}


GType network_wifi_menu_item_get_type (void) {
	static volatile gsize network_wifi_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
		g_once_init_leave (&network_wifi_menu_item_type_id__volatile, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__volatile;
}


static void _vala_network_wifi_menu_item_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STRENGTH:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_AP:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1181 "WifiMenuItem.c"
		default:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1187 "WifiMenuItem.c"
	}
}


static void _vala_network_wifi_menu_item_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1203 "WifiMenuItem.c"
		default:
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-network-2.1.1/src/common/Widgets/WifiMenuItem.vala"
		break;
#line 1209 "WifiMenuItem.c"
	}
}



